<HTML>
<HEAD><TITLE>High Level ODI Pipeline Workflow Architecture</TITLE></HEAD>
<BODY>
<CENTER>
<H2>High Level ODI Pipeline Workflow Architecture</H2>
<H3>Francisco Valdes, Nov. 11, 2011</H3>
</CENTER>

<H3> 1. The Pipeline Developer's View </H3>

<P> The architecture of the ODI Automatic Calibration Pipeline (AuCaP) can
be viewed at many levels of granularity.  The pipeline developer's view of
the AuCaP "pipeline application" is of a number of small functional
"pipelines" in a map/reduce organization.  This is also the view for a
native NHPPS pipeline application running on a dedicated cluster.

<P> Figure 1 shows this pipeline developer's view where each element of the
diagram is one of the functional pipelines.  The function of each of these
pipelines and details of the organization may be found in Valdes [<A
HREF="http://chive.tuc.noao.edu/noaodpp/Pipeline/PL013.pdf">PL013</A>].  As
an aside, the pieces in red indicate a prototype workflow.  The lines and
terminators indicate the transformations of mapping (breaking up a dataset
into parallel pieces) and reducing (aggregating the parallel pieces).

<P> The connections also illustrate the traversal of the transformations
through the pipelines.  The traversal is a depth first tree moving from left
to right and top to bottom in the figure.  For example, from the top level
pipeline, called "top", the workflow proceeds first to the caB pipeline and
then the seq pipeline.  When all nodes in the caB pipeline have been
traversed the caF pipeline and its children are next and similarly for the
ftr and ftG pipelines.

<CENTER>
<H4> Figure 1: Pipeline Developer's View
(<FONT COLOR="Red">red = prototype</FONT>) </H4>
<P><A HREF="ODI_NHPPS1A.png" TARGET="PNG"><IMG SRC="ODI_NHPPS1A.png"
WIDTH="500" BORDER="0"></A>
</CENTER>

<H3> 2. The PPA Developer's View </H3>

<P> At a higher architectural level, the primary subject of this document,
the view is as shown in figure 2.  This is the view of the PPA
(Pipeline, Portal, and Archive) system developers.
In this view all the structure in the pipeline tree beyond the first
set of nodes is collapsed into "workflows".

<CENTER>
<H4> Figure 2: PPA Developer's View </H4>
<P><IMG SRC="ODI_NHPPS2A.png" BORDER="0"></A>
</CENTER>

<P>The figure further shows the two key PPA components which encapsulate the
functionality.  The Data Engine is the component that handles data staging,
archiving, and calling the OGCE (Open Grid Computing Environment) workflow
engine to execute the four workflows indicated.

<P> One thing to note is that the "crowfoot" (map) and "vee" (reduce)
terminators indicate the map/reduce transformations.  In figure 2, there is
only one execution of the caB workflow which processes all the bias data,
hence there is no crowfoot terminator.  The other workflows can be
parallized by filters; i.e. the dome flat processing, the static exposure
processing, and the guided exposure processing.  This parallelization is
indicated by the crowfoot terminator.

<P> In figure 3 the architecture of figure 2 is depicted as a sequence
diagram.  The top pipeline is effectively an orchestrator that executes
the sequence of steps shown for the Data Engine.  The top label in the
figure is included simply to indicate that the Data Engine and the
top pipeline are functionally the same.

<CENTER>
<H4> Figure 3: PPA Sequence View </H4>
<P><IMG SRC="Seq1.png" BORDER="0"></A>
</CENTER>

<H3> 3. The Expanded Data Engine Sequence Logic and Components </H3>

<P> The full PPA system dealing with the AuCaP processing involves
several additional components and orchestration logic centered around
the Data Engine as the top level of the workflow.  Figure 4
shows the sequence logic and components (summarized below).

<ul>
<li> trigger and track processing with the Pipeline Scheduling
Agent (PSA)
<li> identify the input raw data with XMCCat (not shown)
<li> group exposures by type and identify calibrations for that type
using the Calibration Planner
<li> stage data for the OGCE workflow engine
<li> trigger the OGCE workflow engine
<li> capture and handle the workflow data products from OGCE
<ul>
<li> provisionally save data products pending review
<li> save calibrations in the Calibration Library
<li> persist data products after review (not shown)
</ul>

<CENTER>
<H4> Figure 4: Full PPA Sequence Diagram (click figure for full size)</H4>
<TABLE>
<TR><TH>Page 1<TH>Page 2</TR>
<TR><TD WIDTH="360" ALIGN="center"><A HREF="Seq2.png" TARGET="PNG"><IMG SRC="Seq2A.png" HEIGHT="500" BORDER="0"></A>
<TD WIDTH="360" ALIGN="center"><A HREF="Seq2.png" TARGET="PNG"><IMG SRC="Seq2B.png" HEIGHT="500" BORDER="0"></A>
</TR>
</TABLE>
</CENTER>

<H4> 3.1. Data Engine and Calibration Planner Interface </H4>

<P> The annotations for the interactions with the calibration planner
indicate VOTables.  Briefly, the inputs and outputs of the calibration
planner are VOTables defining data files (both raw files and
calibration) and relevant metadata needed to assign calibrations to
exposures.  At each step the returned VOTable has two parts, the
files to be using the next workflow and the files to be processed by
subsequent workflows.  This latter table is simply extracted from the
calibration planner output and input the next time it is called.
Examples of VOTables are shown in figures 5 and 6 of the appendix.

<H3> Appendices </H3>

<H4> A. VOTable Examples </H4>

<P>The VOTable for input to the first CalPlan execution consists of a
table of all the OTA files which statisfy the PSA request for a block
of nights.

<H4> <A HREF="VOTables/votable1.xml">
Figure A1: VOTable Input to First Calibration Planner </A> </H4>

<P> In this table there are two parts, the table to be used as input
to the OGCE bias workflow and to be used as input to the next call to
the calibration planner (shown as "Rest" in the sequence diagram of
figure 4).

<H4> <A HREF="VOTables/votable2.xml">
Figure A2: VOTable Output for Bias Workflow </A> </H4>

<P> This table illustrates, using ellipses (...), to show how there
are multiple subresources for each in the resource for data used to
call the caF workflow.  The same logic can apply to all the filter
parallel workflows.

<H4> <A HREF="VOTables/votable3.xml">
Figure A3: VOTable Output for Flat Workflow </A> </H4>

</BODY></HTML>
